fileInFolder = function(folderName, fileName)
	if not file.exists(folderName) then
		print "Folder """ + folderName + """ not found."
		exit
	end if
	return file.child(folderName, fileName)
end function

//initialize var
checkCount = 0
failCount = 0
obj_num=300
erase_buf=240

picture = file.loadImage(fileInFolder("images", "bullet32.png"))

bul_col= ["#000000", "#FFFFFF"]

//class define
CBullet = {"number":0, "x":0, "y":0, "dx":0, "dy":0, "isactive":0}

CBullet.initialize=function( x, y, dx, dy, isactive)
	self.x=x
	self.y=y
	self.dx=dx
	self.dy=dy
	self.isactive=1
end function

CBullet.clear=function()
	self.x=0
	self.y=0
	self.dx=0
	self.dy=0
	self.isactive=0
end function

CBullet.update=function()
	self.x = self.x+self.dx
	self.y = self.y+self.dy

	//self.erase_check()
end function

CBullet.erase_check=function()
	chk = 0
	if self.x>480+erase_buf then
		self.clear()
		chk = 1
	end if

	if self.x<0+erase_buf then
		self.clear()
		chk = 1
	end if

	if self.y>640 then
		self.clear()
		chk = 1
	end if

	if self.y<0 then
		self.clear()
		chk = 1
	end if

	return chk

end function

CBullet.random_init= function()
	self.x=240+erase_buf
	self.y=480
	self.dx = ((rnd * 100)-50)*0.1
	self.dy = ((rnd * 100)-50)*0.1
	self.isactive=1
end function

CBullet.deg_init= function( deg=0 )
	self.x=240+erase_buf
	self.y=480
	spd = 1
	self.dx = cos(deg)*spd
	self.dy = sin(deg)*spd
	self.isactive=1
end function

CBullet.draw=function()
	gfx.fillRect pbul[i].x, pbul[i].y, 10, 10, bul_col[1]
end function


bg_draw=function(frm=0)
		buf_x=480
		buf_y=320
		a=frm%90*8
		b=frm%120*8
		rad_one = 3.1415926535 /180

		gfx.line buf_x+a*cos((90+frm*2)*rad_one),buf_y+a*sin((90+frm*2)*rad_one), 
				buf_x+a*cos((210+frm*2)*rad_one),buf_y+a*sin((210+frm*2)*rad_one)
		gfx.line buf_x+a*cos((210+frm*2)*rad_one),buf_y+a*sin((210+frm*2)*rad_one),
				buf_x+a*cos((330+frm*2)*rad_one),buf_y+a*sin((330+frm*2)*rad_one)
		gfx.line buf_x+a*cos((330+frm*2)*rad_one),buf_y+a*sin((330+frm*2)*rad_one),
				buf_x+a*cos((90+frm*2)*rad_one),buf_y+a*sin((90+frm*2)*rad_one)


		gfx.line buf_x+b*cos((90-frm*2)*rad_one),buf_y+b*sin((90-frm*2)*rad_one), 
				buf_x+b*cos((210-frm*2)*rad_one),buf_y+b*sin((210-frm*2)*rad_one)
		gfx.line buf_x+b*cos((210-frm*2)*rad_one),buf_y+b*sin((210-frm*2)*rad_one),
				buf_x+b*cos((330-frm*2)*rad_one),buf_y+b*sin((330-frm*2)*rad_one)
		gfx.line buf_x+b*cos((330-frm*2)*rad_one),buf_y+b*sin((330-frm*2)*rad_one),
				buf_x+b*cos((90-frm*2)*rad_one),buf_y+b*sin((90-frm*2)*rad_one)
end function

//display mode change
//self_graph=[gfx, g]

//gfx.clear

//Initialize
//fps cnt
prev_time=time()
fps = 0


frame = 0
move_bullet=0

pobj = []

while not key.pressed("return")
	add_flag = 0
	move_bullet=pobj.len
	perase = []
	minus = 0

	//added obj move
	if move_bullet >0 then
		for i in range(0, move_bullet-1)
			temp = pobj[i-minus]
			temp.update()

			//sprite update
			t_spr = sprites[i-minus]
			t_spr.x = temp.x
			t_spr.y = temp.y

			pobj[i-minus] = temp
			sprites[i-minus] = t_spr

			//erase_check
			chk = temp.erase_check()
			if chk ==1 then
				pobj.remove(i-minus)
				sprites.remove(i-minus)
				minus = minus+1
			end if
		end for
	end if

	//obj added
	if frame%2 == 0 then
		obj = new CBullet
		obj.deg_init(frame)
		pobj.push(obj)

		spr = new Sprite
		spr.image=picture //loadimage
		spr.x=obj.x
		spr.y=obj.y
		spr.scale=0.5
		sprites.push spr //register sprites
	end if

	//draw bg
	if frame %2 ==0 then
		gfx.clear
		bg_draw(frame)
	end if

	//time calcurate
	if time()-prev_time>1.0 then
		fps=fps+1
		text.clear
		print "FPS : "+fps
		print "bullet : "+move_bullet
		print pobj.len
		print sprites.len
		fps=0
		prev_time=time()
	else
		fps=fps+1
	end if
		
	frame=frame+1
	
	yield
end while

